require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&LLABEL)) {
    sub LLABEL {
	my($name,$num) = @_;
	eval q( &L  $name  $num);
    }
}
if(defined(&PROF) || (defined(&_KERNEL)  && defined(&GPROF))) {
    eval 'sub MCOUNT () { &alloc  &out0 =  ($ar->{pfs}), 8, 0, 4, 0;  &mov  &out1 =  &r1;  &mov  &out2 =  &b0;;  &mov  &out3 =  &r0;  ($br->{call}->{sptk})  &b0 =  &_mcount;;;}' unless defined(&MCOUNT);
} else {
    eval 'sub MCOUNT () {1;}' unless defined(&MCOUNT);
}
unless(defined(&ENTRY)) {
    sub ENTRY {
	my($_name_, $_n_args_) = @_;
	eval q(. &global $_name_; . &align 32; . &proc $_name_; $_name_:; . &regstk $_n_args_, 0, 0, 0;  &MCOUNT);
    }
}
unless(defined(&ENTRY_NOPROFILE)) {
    sub ENTRY_NOPROFILE {
	my($_name_, $_n_args_) = @_;
	eval q(. &global $_name_; . &align 32; . &proc $_name_; $_name_:; . &regstk $_n_args_, 0, 0, 0);
    }
}
unless(defined(&STATIC_ENTRY)) {
    sub STATIC_ENTRY {
	my($_name_, $_n_args_) = @_;
	eval q(. &align 32; . &proc $_name_; $_name_:; . &regstk $_n_args_, 0, 0, 0 &MCOUNT);
    }
}
unless(defined(&XENTRY)) {
    sub XENTRY {
	my($_name_) = @_;
	eval q(. &globl $_name_; $_name_:);
    }
}
unless(defined(&STATIC_XENTRY)) {
    sub STATIC_XENTRY {
	my($_name_) = @_;
	eval q($_name_:);
    }
}
unless(defined(&END)) {
    sub END {
	my($_name_) = @_;
	eval q(. &endp $_name_);
    }
}
unless(defined(&EXPORT)) {
    sub EXPORT {
	my($_name_) = @_;
	eval q(. &global $_name_; $_name_:);
    }
}
unless(defined(&IMPORT)) {
    sub IMPORT {
	my($_name_, $_size_) = @_;
	eval q();
    }
}
unless(defined(&ABS)) {
    sub ABS {
	my($_name_, $_value_) = @_;
	eval q(. &globl $_name_; $_name_ = $_value_);
    }
}
unless(defined(&BSS)) {
    sub BSS {
	my($_name_,$_numbytes_) = @_;
	eval q(. &comm $_name_,$_numbytes_);
    }
}
eval 'sub ASCIZ () {. &asciz;}' unless defined(&ASCIZ);
unless(defined(&MSG)) {
    sub MSG {
	my($msg,$reg,$label) = @_;
	eval q( &addl $reg,@ &ltoff($label), &gp;;  &ld8 $reg=[$reg];; . &data; $label:  &ASCIZ $msg; . &text;);
    }
}
unless(defined(&SYSCALLNUM)) {
    sub SYSCALLNUM {
	my($name) = @_;
	eval q( &SYS_  $name);
    }
}
unless(defined(&CALLSYS_NOERROR)) {
    sub CALLSYS_NOERROR {
	my($name) = @_;
	eval q(. &prologue ; . &unwabi @ &svr4, ord('S') ; . &save  &rp,  &r0 ; . &body ; { . &mmi ;  &alloc  &r9 =  ($ar->{pfs}), 0, 0, 8, 0;  &mov  &r31 =  ($ar->{k5}) ;  &mov  &r10 =  &b0 ;; } { . &mib ;  &mov  &r8 =  &SYSCALLNUM($name) ;  &mov  &b7 =  &r31 ;  ($br->{call}->{sptk})	 &b0 =  &b7 ;; });
    }
}
unless(defined(&WEAK_ALIAS)) {
    sub WEAK_ALIAS {
	my($alias,$sym) = @_;
	eval q(. &weak $alias; $alias = $sym);
    }
}
if(!defined(&lint)  && !defined(&STRIP_FBSDID)) {
    eval 'sub __FBSDID {
        my($s) = @_;
	    eval q(. &ident $s);
    }' unless defined(&__FBSDID);
} else {
    eval 'sub __FBSDID {
        my($s) = @_;
	    eval q();
    }' unless defined(&__FBSDID);
}
1;
