require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_H_)) {
    eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
    eval 'sub mb () {
        eval q( &__asm  &__volatile(\\"mf\\"));
    }' unless defined(&mb);
    eval 'sub wmb () {
        eval q( &mb());
    }' unless defined(&wmb);
    eval 'sub rmb () {
        eval q( &mb());
    }' unless defined(&rmb);
    eval 'sub IA64_CMPXCHG {
        my($sz, $sem, $p, $cmpval, $newval, $ret) = @_;
	    eval q( &__asm  &__volatile ( \\"mov ar.ccv=%2;;\\\\n\\\\t\\" \\"cmpxchg\\" $sz \\".\\" $sem \\" %0=%4,%3,ar.ccv\\\\n\\\\t\\" : \\"=r\\" ($ret), \\"=m\\" (*$p) : \\"r\\" (( &uint64_t)$cmpval), \\"r\\" ($newval), \\"m\\" (*$p) : \\"memory\\"));
    }' unless defined(&IA64_CMPXCHG);
    eval 'sub ia64_cmpxchg_rel_32 {
        my($p,$cmpval,$newval) = @_;
	    eval q({  &uint32_t  &ret;  &IA64_CMPXCHG(4,  &rel, $p, $cmpval, $newval,  &ret); ( &ret); });
    }' unless defined(&ia64_cmpxchg_rel_32);
    eval 'sub ia64_cmpxchg_acq_64 {
        my($p,$cmpval,$newval) = @_;
	    eval q({  &uint64_t  &ret;  &IA64_CMPXCHG(8,  &acq, $p, $cmpval, $newval,  &ret); ( &ret); });
    }' unless defined(&ia64_cmpxchg_acq_64);
    eval 'sub ia64_cmpxchg_rel_64 {
        my($p,$cmpval,$newval) = @_;
	    eval q({  &uint64_t  &ret;  &IA64_CMPXCHG(8,  &rel, $p, $cmpval, $newval,  &ret); ( &ret); });
    }' unless defined(&ia64_cmpxchg_rel_64);
    eval 'sub ATOMIC_STORE_LOAD {
        my($type, $width, $size) = @_;
	    eval q( &static  &__inline \'uint\'$width &_t  &ia64_ld_acq_$width( &volatile \'uint\'$width &_t*  &p) { \'uint\'$width &_t  &v;  &__asm  &__volatile (\\"ld\\" $size \\".acq %0=%1\\" : \\"=r\\" ( &v) : \\"m\\" (* &p) : \\"memory\\");  &return ( &v); }  &static  &__inline \'uint\'$width &_t  &atomic_load_acq_$width( &volatile \'uint\'$width &_t*  &p) { \'uint\'$width &_t  &v;  &__asm  &__volatile (\\"ld\\" $size \\".acq %0=%1\\" : \\"=r\\" ( &v) : \\"m\\" (* &p) : \\"memory\\");  &return ( &v); }  &static  &__inline \'uint\'$width &_t  &atomic_load_acq_$type( &volatile \'uint\'$width &_t*  &p) { \'uint\'$width &_t  &v;  &__asm  &__volatile (\\"ld\\" $size \\".acq %0=%1\\" : \\"=r\\" ( &v) : \\"m\\" (* &p) : \\"memory\\");  &return ( &v); }  &static  &__inline  &void  &ia64_st_rel_$width( &volatile \'uint\'$width &_t*  &p, \'uint\'$width &_t  &v) {  &__asm  &__volatile (\\"st\\" $size \\".rel %0=%1\\" : \\"=m\\" (* &p) : \\"r\\" ( &v) : \\"memory\\"); }  &static  &__inline  &void  &atomic_store_rel_$width( &volatile \'uint\'$width &_t*  &p, \'uint\'$width &_t  &v) {  &__asm  &__volatile (\\"st\\" $size \\".rel %0=%1\\" : \\"=m\\" (* &p) : \\"r\\" ( &v) : \\"memory\\"); }  &static  &__inline  &void  &atomic_store_rel_$type( &volatile \'uint\'$width &_t*  &p, \'uint\'$width &_t  &v) {  &__asm  &__volatile (\\"st\\" $size \\".rel %0=%1\\" : \\"=m\\" (* &p) : \\"r\\" ( &v) : \\"memory\\"); });
    }' unless defined(&ATOMIC_STORE_LOAD);
    undef(&ATOMIC_STORE_LOAD) if defined(&ATOMIC_STORE_LOAD);
    eval 'sub atomic_load_acq_ptr {
        my($p) = @_;
	    eval q((( &void *) &atomic_load_acq_64(( &volatile  &uint64_t *)$p)));
    }' unless defined(&atomic_load_acq_ptr);
    eval 'sub atomic_store_rel_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_store_rel_64(( &volatile  &uint64_t *)$p, ( &uint64_t)$v));
    }' unless defined(&atomic_store_rel_ptr);
    eval 'sub IA64_ATOMIC {
        my($sz, $type, $name, $width, $op) = @_;
	    eval q( &static  &__inline $type  &atomic_$name &_acq_$width( &volatile $type * &p, $type  &v) { $type  &old,  &ret;  &do {  &old = * &p;  &IA64_CMPXCHG($sz,  &acq,  &p,  &old,  &old $op  &v,  &ret); }  &while ( &ret !=  &old);  &return ( &old); }  &static  &__inline $type  &atomic_$name &_rel_$width( &volatile $type * &p, $type  &v) { $type  &old,  &ret;  &do {  &old = * &p;  &IA64_CMPXCHG($sz,  &rel,  &p,  &old,  &old $op  &v,  &ret); }  &while ( &ret !=  &old);  &return ( &old); });
    }' unless defined(&IA64_ATOMIC);
    undef(&IA64_ATOMIC) if defined(&IA64_ATOMIC);
    eval 'sub atomic_set_8 () { &atomic_set_acq_8;}' unless defined(&atomic_set_8);
    eval 'sub atomic_clear_8 () { &atomic_clear_acq_8;}' unless defined(&atomic_clear_8);
    eval 'sub atomic_add_8 () { &atomic_add_acq_8;}' unless defined(&atomic_add_8);
    eval 'sub atomic_subtract_8 () { &atomic_subtract_acq_8;}' unless defined(&atomic_subtract_8);
    eval 'sub atomic_set_16 () { &atomic_set_acq_16;}' unless defined(&atomic_set_16);
    eval 'sub atomic_clear_16 () { &atomic_clear_acq_16;}' unless defined(&atomic_clear_16);
    eval 'sub atomic_add_16 () { &atomic_add_acq_16;}' unless defined(&atomic_add_16);
    eval 'sub atomic_subtract_16 () { &atomic_subtract_acq_16;}' unless defined(&atomic_subtract_16);
    eval 'sub atomic_set_32 () { &atomic_set_acq_32;}' unless defined(&atomic_set_32);
    eval 'sub atomic_clear_32 () { &atomic_clear_acq_32;}' unless defined(&atomic_clear_32);
    eval 'sub atomic_add_32 () { &atomic_add_acq_32;}' unless defined(&atomic_add_32);
    eval 'sub atomic_subtract_32 () { &atomic_subtract_acq_32;}' unless defined(&atomic_subtract_32);
    eval 'sub atomic_set_64 () { &atomic_set_acq_64;}' unless defined(&atomic_set_64);
    eval 'sub atomic_clear_64 () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_64);
    eval 'sub atomic_add_64 () { &atomic_add_acq_64;}' unless defined(&atomic_add_64);
    eval 'sub atomic_subtract_64 () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_64);
    eval 'sub atomic_set_char () { &atomic_set_8;}' unless defined(&atomic_set_char);
    eval 'sub atomic_clear_char () { &atomic_clear_8;}' unless defined(&atomic_clear_char);
    eval 'sub atomic_add_char () { &atomic_add_8;}' unless defined(&atomic_add_char);
    eval 'sub atomic_subtract_char () { &atomic_subtract_8;}' unless defined(&atomic_subtract_char);
    eval 'sub atomic_set_acq_char () { &atomic_set_acq_8;}' unless defined(&atomic_set_acq_char);
    eval 'sub atomic_clear_acq_char () { &atomic_clear_acq_8;}' unless defined(&atomic_clear_acq_char);
    eval 'sub atomic_add_acq_char () { &atomic_add_acq_8;}' unless defined(&atomic_add_acq_char);
    eval 'sub atomic_subtract_acq_char () { &atomic_subtract_acq_8;}' unless defined(&atomic_subtract_acq_char);
    eval 'sub atomic_set_rel_char () { &atomic_set_rel_8;}' unless defined(&atomic_set_rel_char);
    eval 'sub atomic_clear_rel_char () { &atomic_clear_rel_8;}' unless defined(&atomic_clear_rel_char);
    eval 'sub atomic_add_rel_char () { &atomic_add_rel_8;}' unless defined(&atomic_add_rel_char);
    eval 'sub atomic_subtract_rel_char () { &atomic_subtract_rel_8;}' unless defined(&atomic_subtract_rel_char);
    eval 'sub atomic_set_short () { &atomic_set_16;}' unless defined(&atomic_set_short);
    eval 'sub atomic_clear_short () { &atomic_clear_16;}' unless defined(&atomic_clear_short);
    eval 'sub atomic_add_short () { &atomic_add_16;}' unless defined(&atomic_add_short);
    eval 'sub atomic_subtract_short () { &atomic_subtract_16;}' unless defined(&atomic_subtract_short);
    eval 'sub atomic_set_acq_short () { &atomic_set_acq_16;}' unless defined(&atomic_set_acq_short);
    eval 'sub atomic_clear_acq_short () { &atomic_clear_acq_16;}' unless defined(&atomic_clear_acq_short);
    eval 'sub atomic_add_acq_short () { &atomic_add_acq_16;}' unless defined(&atomic_add_acq_short);
    eval 'sub atomic_subtract_acq_short () { &atomic_subtract_acq_16;}' unless defined(&atomic_subtract_acq_short);
    eval 'sub atomic_set_rel_short () { &atomic_set_rel_16;}' unless defined(&atomic_set_rel_short);
    eval 'sub atomic_clear_rel_short () { &atomic_clear_rel_16;}' unless defined(&atomic_clear_rel_short);
    eval 'sub atomic_add_rel_short () { &atomic_add_rel_16;}' unless defined(&atomic_add_rel_short);
    eval 'sub atomic_subtract_rel_short () { &atomic_subtract_rel_16;}' unless defined(&atomic_subtract_rel_short);
    eval 'sub atomic_set_int () { &atomic_set_32;}' unless defined(&atomic_set_int);
    eval 'sub atomic_clear_int () { &atomic_clear_32;}' unless defined(&atomic_clear_int);
    eval 'sub atomic_add_int () { &atomic_add_32;}' unless defined(&atomic_add_int);
    eval 'sub atomic_subtract_int () { &atomic_subtract_32;}' unless defined(&atomic_subtract_int);
    eval 'sub atomic_set_acq_int () { &atomic_set_acq_32;}' unless defined(&atomic_set_acq_int);
    eval 'sub atomic_clear_acq_int () { &atomic_clear_acq_32;}' unless defined(&atomic_clear_acq_int);
    eval 'sub atomic_add_acq_int () { &atomic_add_acq_32;}' unless defined(&atomic_add_acq_int);
    eval 'sub atomic_subtract_acq_int () { &atomic_subtract_acq_32;}' unless defined(&atomic_subtract_acq_int);
    eval 'sub atomic_set_rel_int () { &atomic_set_rel_32;}' unless defined(&atomic_set_rel_int);
    eval 'sub atomic_clear_rel_int () { &atomic_clear_rel_32;}' unless defined(&atomic_clear_rel_int);
    eval 'sub atomic_add_rel_int () { &atomic_add_rel_32;}' unless defined(&atomic_add_rel_int);
    eval 'sub atomic_subtract_rel_int () { &atomic_subtract_rel_32;}' unless defined(&atomic_subtract_rel_int);
    eval 'sub atomic_set_long () { &atomic_set_64;}' unless defined(&atomic_set_long);
    eval 'sub atomic_clear_long () { &atomic_clear_64;}' unless defined(&atomic_clear_long);
    eval 'sub atomic_add_long () { &atomic_add_64;}' unless defined(&atomic_add_long);
    eval 'sub atomic_subtract_long () { &atomic_subtract_64;}' unless defined(&atomic_subtract_long);
    eval 'sub atomic_set_acq_long () { &atomic_set_acq_64;}' unless defined(&atomic_set_acq_long);
    eval 'sub atomic_clear_acq_long () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_long);
    eval 'sub atomic_add_acq_long () { &atomic_add_acq_64;}' unless defined(&atomic_add_acq_long);
    eval 'sub atomic_subtract_acq_long () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_long);
    eval 'sub atomic_set_rel_long () { &atomic_set_rel_64;}' unless defined(&atomic_set_rel_long);
    eval 'sub atomic_clear_rel_long () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_long);
    eval 'sub atomic_add_rel_long () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_long);
    eval 'sub atomic_subtract_rel_long () { &atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_long);
    eval 'sub atomic_set_ptr () { &atomic_set_64;}' unless defined(&atomic_set_ptr);
    eval 'sub atomic_clear_ptr () { &atomic_clear_64;}' unless defined(&atomic_clear_ptr);
    eval 'sub atomic_add_ptr () { &atomic_add_64;}' unless defined(&atomic_add_ptr);
    eval 'sub atomic_subtract_ptr () { &atomic_subtract_64;}' unless defined(&atomic_subtract_ptr);
    eval 'sub atomic_set_acq_ptr () { &atomic_set_acq_64;}' unless defined(&atomic_set_acq_ptr);
    eval 'sub atomic_clear_acq_ptr () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_ptr);
    eval 'sub atomic_add_acq_ptr () { &atomic_add_acq_64;}' unless defined(&atomic_add_acq_ptr);
    eval 'sub atomic_subtract_acq_ptr () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_ptr);
    eval 'sub atomic_set_rel_ptr () { &atomic_set_rel_64;}' unless defined(&atomic_set_rel_ptr);
    eval 'sub atomic_clear_rel_ptr () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_ptr);
    eval 'sub atomic_add_rel_ptr () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_ptr);
    eval 'sub atomic_subtract_rel_ptr () { &atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_ptr);
    undef(&IA64_CMPXCHG) if defined(&IA64_CMPXCHG);
    eval 'sub atomic_cmpset_rel_32 {
        my($p,$cmpval,$newval) = @_;
	    eval q({ ( &ia64_cmpxchg_rel_32($p, $cmpval, $newval) == $cmpval); });
    }' unless defined(&atomic_cmpset_rel_32);
    eval 'sub atomic_cmpset_rel_64 {
        my($p,$cmpval,$newval) = @_;
	    eval q({ ( &ia64_cmpxchg_rel_64($p, $cmpval, $newval) == $cmpval); });
    }' unless defined(&atomic_cmpset_rel_64);
    eval 'sub atomic_cmpset_32 () { &atomic_cmpset_acq_32;}' unless defined(&atomic_cmpset_32);
    eval 'sub atomic_cmpset_64 () { &atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_64);
    eval 'sub atomic_cmpset_int () { &atomic_cmpset_32;}' unless defined(&atomic_cmpset_int);
    eval 'sub atomic_cmpset_long () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_long);
    eval 'sub atomic_cmpset_acq_int () { &atomic_cmpset_acq_32;}' unless defined(&atomic_cmpset_acq_int);
    eval 'sub atomic_cmpset_rel_int () { &atomic_cmpset_rel_32;}' unless defined(&atomic_cmpset_rel_int);
    eval 'sub atomic_cmpset_acq_long () { &atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_acq_long);
    eval 'sub atomic_cmpset_rel_long () { &atomic_cmpset_rel_64;}' unless defined(&atomic_cmpset_rel_long);
    eval 'sub atomic_cmpset_acq_ptr {
        my($p, $o, $n) = @_;
	    eval q(( &atomic_cmpset_acq_64(( &volatile  &uint64_t *)$p, ( &uint64_t)$o, ( &uint64_t)$n)));
    }' unless defined(&atomic_cmpset_acq_ptr);
    eval 'sub atomic_cmpset_ptr () { &atomic_cmpset_acq_ptr;}' unless defined(&atomic_cmpset_ptr);
    eval 'sub atomic_cmpset_rel_ptr {
        my($p, $o, $n) = @_;
	    eval q(( &atomic_cmpset_rel_64(( &volatile  &uint64_t *)$p, ( &uint64_t)$o, ( &uint64_t)$n)));
    }' unless defined(&atomic_cmpset_rel_ptr);
    eval 'sub atomic_readandclear_32 {
        my($p) = @_;
	    eval q({  &uint32_t  &val;  &do {  &val = *$p; }  &while (! &atomic_cmpset_32($p,  &val, 0)); ( &val); });
    }' unless defined(&atomic_readandclear_32);
    eval 'sub atomic_readandclear_64 {
        my($p) = @_;
	    eval q({  &uint64_t  &val;  &do {  &val = *$p; }  &while (! &atomic_cmpset_64($p,  &val, 0)); ( &val); });
    }' unless defined(&atomic_readandclear_64);
    eval 'sub atomic_readandclear_int () { &atomic_readandclear_32;}' unless defined(&atomic_readandclear_int);
    eval 'sub atomic_readandclear_long () { &atomic_readandclear_64;}' unless defined(&atomic_readandclear_long);
    eval 'sub atomic_readandclear_ptr () { &atomic_readandclear_64;}' unless defined(&atomic_readandclear_ptr);
    eval 'sub atomic_fetchadd_int () { &atomic_fetchadd_32;}' unless defined(&atomic_fetchadd_int);
    eval 'sub atomic_fetchadd_long {
        my($p,$v) = @_;
	    eval q({ my $value;  &do {  $value = *$p; }  &while (! &atomic_cmpset_64($p,  $value,  $value + $v)); ( $value); });
    }' unless defined(&atomic_fetchadd_long);
    eval 'sub atomic_swap_64 {
        my($p,$v) = @_;
	    eval q({  &uint64_t  &r;  &__asm  &__volatile (\\"xchg8 %0 = %3, %2;;\\" : \\"=r\\"( &r), \\"=m\\"(*$p) : \\"r\\"($v), \\"m\\"(*$p) : \\"memory\\"); ( &r); });
    }' unless defined(&atomic_swap_64);
    eval 'sub atomic_swap_int () { &atomic_swap_32;}' unless defined(&atomic_swap_int);
    eval 'sub atomic_swap_long () { &atomic_swap_64;}' unless defined(&atomic_swap_long);
    eval 'sub atomic_swap_ptr () { &atomic_swap_64;}' unless defined(&atomic_swap_ptr);
}
1;
