require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_BUS_H_)) {
    eval 'sub _MACHINE_BUS_H_ () {1;}' unless defined(&_MACHINE_BUS_H_);
    require 'machine/_bus.ph';
    require 'machine/cpufunc.ph';
    eval 'sub inb () { &bus_space_read_io_1;}' unless defined(&inb);
    eval 'sub inw () { &bus_space_read_io_2;}' unless defined(&inw);
    eval 'sub inl () { &bus_space_read_io_4;}' unless defined(&inl);
    eval 'sub outb () { &bus_space_write_io_1;}' unless defined(&outb);
    eval 'sub outw () { &bus_space_write_io_2;}' unless defined(&outw);
    eval 'sub outl () { &bus_space_write_io_4;}' unless defined(&outl);
    eval 'sub IA64_BUS_SPACE_IO () {0;}' unless defined(&IA64_BUS_SPACE_IO);
    eval 'sub IA64_BUS_SPACE_MEM () {1;}' unless defined(&IA64_BUS_SPACE_MEM);
    eval 'sub BUS_SPACE_BARRIER_READ () {0x1;}' unless defined(&BUS_SPACE_BARRIER_READ);
    eval 'sub BUS_SPACE_BARRIER_WRITE () {0x2;}' unless defined(&BUS_SPACE_BARRIER_WRITE);
    eval 'sub BUS_SPACE_MAXSIZE_24BIT () {0xffffff;}' unless defined(&BUS_SPACE_MAXSIZE_24BIT);
    eval 'sub BUS_SPACE_MAXSIZE_32BIT () {0xffffffff;}' unless defined(&BUS_SPACE_MAXSIZE_32BIT);
    eval 'sub BUS_SPACE_MAXSIZE () {0xffffffffffffffff;}' unless defined(&BUS_SPACE_MAXSIZE);
    eval 'sub BUS_SPACE_MAXADDR_24BIT () {0xffffff;}' unless defined(&BUS_SPACE_MAXADDR_24BIT);
    eval 'sub BUS_SPACE_MAXADDR_32BIT () {0xffffffff;}' unless defined(&BUS_SPACE_MAXADDR_32BIT);
    eval 'sub BUS_SPACE_MAXADDR () {0xffffffffffffffff;}' unless defined(&BUS_SPACE_MAXADDR);
    eval 'sub BUS_SPACE_UNRESTRICTED () {(~0);}' unless defined(&BUS_SPACE_UNRESTRICTED);
    if(defined(&_KERNEL)) {
	eval 'sub bus_space_read_1 {
	    my($bst,$bsh,$ofs) = @_;
    	    eval q({  &uint8_t  &val;  &val = ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO)) ?  &bus_space_read_io_1($bsh + $ofs) :  &ia64_ld1(( &void *)($bsh + $ofs)); ( &val); });
	}' unless defined(&bus_space_read_1);
	eval 'sub bus_space_read_2 {
	    my($bst,$bsh,$ofs) = @_;
    	    eval q({  &uint16_t  &val;  &val = ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO)) ?  &bus_space_read_io_2($bsh + $ofs) :  &ia64_ld2(( &void *)($bsh + $ofs)); ( &val); });
	}' unless defined(&bus_space_read_2);
	eval 'sub bus_space_read_4 {
	    my($bst,$bsh,$ofs) = @_;
    	    eval q({  &uint32_t  &val;  &val = ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO)) ?  &bus_space_read_io_4($bsh + $ofs) :  &ia64_ld4(( &void *)($bsh + $ofs)); ( &val); });
	}' unless defined(&bus_space_read_4);
	eval 'sub bus_space_read_8 {
	    my($bst,$bsh,$ofs) = @_;
    	    eval q({  &uint64_t  &val;  &val = ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO)) ?  &bus_space_read_io_8($bsh + $ofs) :  &ia64_ld8(( &void *)($bsh + $ofs)); ( &val); });
	}' unless defined(&bus_space_read_8);
	eval 'sub bus_space_write_1 {
	    my($bst,$bsh,$ofs,$val) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_io_1($bsh + $ofs, $val);  &else  &ia64_st1(( &void *)($bsh + $ofs), $val); });
	}' unless defined(&bus_space_write_1);
	eval 'sub bus_space_write_2 {
	    my($bst,$bsh,$ofs,$val) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_io_2($bsh + $ofs, $val);  &else  &ia64_st2(( &void *)($bsh + $ofs), $val); });
	}' unless defined(&bus_space_write_2);
	eval 'sub bus_space_write_4 {
	    my($bst,$bsh,$ofs,$val) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_io_4($bsh + $ofs, $val);  &else  &ia64_st4(( &void *)($bsh + $ofs), $val); });
	}' unless defined(&bus_space_write_4);
	eval 'sub bus_space_write_8 {
	    my($bst,$bsh,$ofs,$val) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_io_8($bsh + $ofs, $val);  &else  &ia64_st8(( &void *)($bsh + $ofs), $val); });
	}' unless defined(&bus_space_write_8);
	eval 'sub bus_space_read_multi_1 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_read_multi_io_1($bsh + $ofs, $bufp, $count);  &else {  &while ($count-- > 0) *$bufp++ =  &ia64_ld1(( &void *)($bsh + $ofs)); } });
	}' unless defined(&bus_space_read_multi_1);
	eval 'sub bus_space_read_multi_2 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_read_multi_io_2($bsh + $ofs, $bufp, $count);  &else {  &while ($count-- > 0) *$bufp++ =  &ia64_ld2(( &void *)($bsh + $ofs)); } });
	}' unless defined(&bus_space_read_multi_2);
	eval 'sub bus_space_read_multi_4 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_read_multi_io_4($bsh + $ofs, $bufp, $count);  &else {  &while ($count-- > 0) *$bufp++ =  &ia64_ld4(( &void *)($bsh + $ofs)); } });
	}' unless defined(&bus_space_read_multi_4);
	eval 'sub bus_space_read_multi_8 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_read_multi_io_8($bsh + $ofs, $bufp, $count);  &else {  &while ($count-- > 0) *$bufp++ =  &ia64_ld8(( &void *)($bsh + $ofs)); } });
	}' unless defined(&bus_space_read_multi_8);
	eval 'sub bus_space_write_multi_1 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_multi_io_1($bsh + $ofs, $bufp, $count);  &else {  &while ($count-- > 0)  &ia64_st1(( &void *)($bsh + $ofs), *$bufp++); } });
	}' unless defined(&bus_space_write_multi_1);
	eval 'sub bus_space_write_multi_2 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_multi_io_2($bsh + $ofs, $bufp, $count);  &else {  &while ($count-- > 0)  &ia64_st2(( &void *)($bsh + $ofs), *$bufp++); } });
	}' unless defined(&bus_space_write_multi_2);
	eval 'sub bus_space_write_multi_4 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_multi_io_4($bsh + $ofs, $bufp, $count);  &else {  &while ($count-- > 0)  &ia64_st4(( &void *)($bsh + $ofs), *$bufp++); } });
	}' unless defined(&bus_space_write_multi_4);
	eval 'sub bus_space_write_multi_8 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_multi_io_8($bsh + $ofs, $bufp, $count);  &else {  &while ($count-- > 0)  &ia64_st8(( &void *)($bsh + $ofs), *$bufp++); } });
	}' unless defined(&bus_space_write_multi_8);
	eval 'sub bus_space_read_region_1 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_read_region_io_1($bsh + $ofs, $bufp, $count);  &else {  &uint8_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0) *$bufp++ =  &ia64_ld1( &bsp++); } });
	}' unless defined(&bus_space_read_region_1);
	eval 'sub bus_space_read_region_2 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_read_region_io_2($bsh + $ofs, $bufp, $count);  &else {  &uint16_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0) *$bufp++ =  &ia64_ld2( &bsp++); } });
	}' unless defined(&bus_space_read_region_2);
	eval 'sub bus_space_read_region_4 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_read_region_io_4($bsh + $ofs, $bufp, $count);  &else {  &uint32_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0) *$bufp++ =  &ia64_ld4( &bsp++); } });
	}' unless defined(&bus_space_read_region_4);
	eval 'sub bus_space_read_region_8 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_read_region_io_8($bsh + $ofs, $bufp, $count);  &else {  &uint64_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0) *$bufp++ =  &ia64_ld8( &bsp++); } });
	}' unless defined(&bus_space_read_region_8);
	eval 'sub bus_space_write_region_1 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_region_io_1($bsh + $ofs, $bufp, $count);  &else {  &uint8_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0)  &ia64_st1( &bsp++, *$bufp++); } });
	}' unless defined(&bus_space_write_region_1);
	eval 'sub bus_space_write_region_2 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_region_io_2($bsh + $ofs, $bufp, $count);  &else {  &uint16_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0)  &ia64_st2( &bsp++, *$bufp++); } });
	}' unless defined(&bus_space_write_region_2);
	eval 'sub bus_space_write_region_4 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_region_io_4($bsh + $ofs, $bufp, $count);  &else {  &uint32_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0)  &ia64_st4( &bsp++, *$bufp++); } });
	}' unless defined(&bus_space_write_region_4);
	eval 'sub bus_space_write_region_8 {
	    my($bst,$bsh,$ofs,$bufp,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_write_region_io_8($bsh + $ofs, $bufp, $count);  &else {  &uint64_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0)  &ia64_st8( &bsp++, *$bufp++); } });
	}' unless defined(&bus_space_write_region_8);
	eval 'sub bus_space_set_multi_2 {
	    my($bst,$bsh,$ofs,$val,$count) = @_;
    	    eval q({  &while ($count-- > 0)  &bus_space_write_2($bst, $bsh, $ofs, $val); });
	}' unless defined(&bus_space_set_multi_2);
	eval 'sub bus_space_set_multi_4 {
	    my($bst,$bsh,$ofs,$val,$count) = @_;
    	    eval q({  &while ($count-- > 0)  &bus_space_write_4($bst, $bsh, $ofs, $val); });
	}' unless defined(&bus_space_set_multi_4);
	eval 'sub bus_space_set_multi_8 {
	    my($bst,$bsh,$ofs,$val,$count) = @_;
    	    eval q({  &while ($count-- > 0)  &bus_space_write_8($bst, $bsh, $ofs, $val); });
	}' unless defined(&bus_space_set_multi_8);
	eval 'sub bus_space_set_region_1 {
	    my($bst,$bsh,$ofs,$val,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_set_region_io_1($bsh + $ofs, $val, $count);  &else {  &uint8_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0)  &ia64_st1( &bsp++, $val); } });
	}' unless defined(&bus_space_set_region_1);
	eval 'sub bus_space_set_region_2 {
	    my($bst,$bsh,$ofs,$val,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_set_region_io_2($bsh + $ofs, $val, $count);  &else {  &uint16_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0)  &ia64_st2( &bsp++, $val); } });
	}' unless defined(&bus_space_set_region_2);
	eval 'sub bus_space_set_region_4 {
	    my($bst,$bsh,$ofs,$val,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_set_region_io_4($bsh + $ofs, $val, $count);  &else {  &uint32_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0)  &ia64_st4( &bsp++, $val); } });
	}' unless defined(&bus_space_set_region_4);
	eval 'sub bus_space_set_region_8 {
	    my($bst,$bsh,$ofs,$val,$count) = @_;
    	    eval q({  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO))  &bus_space_set_region_io_4($bsh + $ofs, $val, $count);  &else {  &uint64_t * &bsp = ( &void *)($bsh + $ofs);  &while ($count-- > 0)  &ia64_st8( &bsp++, $val); } });
	}' unless defined(&bus_space_set_region_8);
	eval 'sub bus_space_copy_region_1 {
	    my($bst,$sbsh,$sofs,$dbsh,$dofs,$count) = @_;
    	    eval q({  &uint8_t * &dst, * &src;  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO)) {  &bus_space_copy_region_io_1($sbsh + $sofs, $dbsh + $dofs, $count); ; }  &src = ( &void *)($sbsh + $sofs);  &dst = ( &void *)($dbsh + $dofs);  &if ( &src <  &dst) {  &src += $count - 1;  &dst += $count - 1;  &while ($count-- > 0)  &ia64_st1( &dst--,  &ia64_ld1( &src--)); }  &else {  &while ($count-- > 0)  &ia64_st1( &dst++,  &ia64_ld1( &src++)); } });
	}' unless defined(&bus_space_copy_region_1);
	eval 'sub bus_space_copy_region_2 {
	    my($bst,$sbsh,$sofs,$dbsh,$dofs,$count) = @_;
    	    eval q({  &uint16_t * &dst, * &src;  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO)) {  &bus_space_copy_region_io_2($sbsh + $sofs, $dbsh + $dofs, $count); ; }  &src = ( &void *)($sbsh + $sofs);  &dst = ( &void *)($dbsh + $dofs);  &if ( &src <  &dst) {  &src += $count - 1;  &dst += $count - 1;  &while ($count-- > 0)  &ia64_st2( &dst--,  &ia64_ld2( &src--)); }  &else {  &while ($count-- > 0)  &ia64_st2( &dst++,  &ia64_ld2( &src++)); } });
	}' unless defined(&bus_space_copy_region_2);
	eval 'sub bus_space_copy_region_4 {
	    my($bst,$sbsh,$sofs,$dbsh,$dofs,$count) = @_;
    	    eval q({  &uint32_t * &dst, * &src;  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO)) {  &bus_space_copy_region_io_4($sbsh + $sofs, $dbsh + $dofs, $count); ; }  &src = ( &void *)($sbsh + $sofs);  &dst = ( &void *)($dbsh + $dofs);  &if ( &src <  &dst) {  &src += $count - 1;  &dst += $count - 1;  &while ($count-- > 0)  &ia64_st4( &dst--,  &ia64_ld4( &src--)); }  &else {  &while ($count-- > 0)  &ia64_st4( &dst++,  &ia64_ld4( &src++)); } });
	}' unless defined(&bus_space_copy_region_4);
	eval 'sub bus_space_copy_region_8 {
	    my($bst,$sbsh,$sofs,$dbsh,$dofs,$count) = @_;
    	    eval q({  &uint64_t * &dst, * &src;  &if ( &__predict_false($bst ==  &IA64_BUS_SPACE_IO)) {  &bus_space_copy_region_io_8($sbsh + $sofs, $dbsh + $dofs, $count); ; }  &src = ( &void *)($sbsh + $sofs);  &dst = ( &void *)($dbsh + $dofs);  &if ( &src <  &dst) {  &src += $count - 1;  &dst += $count - 1;  &while ($count-- > 0)  &ia64_st8( &dst--,  &ia64_ld8( &src--)); }  &else {  &while ($count-- > 0)  &ia64_st8( &dst++,  &ia64_ld8( &src++)); } });
	}' unless defined(&bus_space_copy_region_8);
	eval 'sub bus_space_read_stream_1 () { &bus_space_read_1;}' unless defined(&bus_space_read_stream_1);
	eval 'sub bus_space_read_stream_2 () { &bus_space_read_2;}' unless defined(&bus_space_read_stream_2);
	eval 'sub bus_space_read_stream_4 () { &bus_space_read_4;}' unless defined(&bus_space_read_stream_4);
	eval 'sub bus_space_read_stream_8 () { &bus_space_read_8;}' unless defined(&bus_space_read_stream_8);
	eval 'sub bus_space_write_stream_1 () { &bus_space_write_1;}' unless defined(&bus_space_write_stream_1);
	eval 'sub bus_space_write_stream_2 () { &bus_space_write_2;}' unless defined(&bus_space_write_stream_2);
	eval 'sub bus_space_write_stream_4 () { &bus_space_write_4;}' unless defined(&bus_space_write_stream_4);
	eval 'sub bus_space_write_stream_8 () { &bus_space_write_8;}' unless defined(&bus_space_write_stream_8);
	eval 'sub bus_space_read_multi_stream_1 () { &bus_space_read_multi_1;}' unless defined(&bus_space_read_multi_stream_1);
	eval 'sub bus_space_read_multi_stream_2 () { &bus_space_read_multi_2;}' unless defined(&bus_space_read_multi_stream_2);
	eval 'sub bus_space_read_multi_stream_4 () { &bus_space_read_multi_4;}' unless defined(&bus_space_read_multi_stream_4);
	eval 'sub bus_space_read_multi_stream_8 () { &bus_space_read_multi_8;}' unless defined(&bus_space_read_multi_stream_8);
	eval 'sub bus_space_write_multi_stream_1 () { &bus_space_write_multi_1;}' unless defined(&bus_space_write_multi_stream_1);
	eval 'sub bus_space_write_multi_stream_2 () { &bus_space_write_multi_2;}' unless defined(&bus_space_write_multi_stream_2);
	eval 'sub bus_space_write_multi_stream_4 () { &bus_space_write_multi_4;}' unless defined(&bus_space_write_multi_stream_4);
	eval 'sub bus_space_write_multi_stream_8 () { &bus_space_write_multi_8;}' unless defined(&bus_space_write_multi_stream_8);
	eval 'sub bus_space_read_region_stream_1 () { &bus_space_read_region_1;}' unless defined(&bus_space_read_region_stream_1);
	eval 'sub bus_space_read_region_stream_2 () { &bus_space_read_region_2;}' unless defined(&bus_space_read_region_stream_2);
	eval 'sub bus_space_read_region_stream_4 () { &bus_space_read_region_4;}' unless defined(&bus_space_read_region_stream_4);
	eval 'sub bus_space_read_region_stream_8 () { &bus_space_read_region_8;}' unless defined(&bus_space_read_region_stream_8);
	eval 'sub bus_space_write_region_stream_1 () { &bus_space_write_region_1;}' unless defined(&bus_space_write_region_stream_1);
	eval 'sub bus_space_write_region_stream_2 () { &bus_space_write_region_2;}' unless defined(&bus_space_write_region_stream_2);
	eval 'sub bus_space_write_region_stream_4 () { &bus_space_write_region_4;}' unless defined(&bus_space_write_region_stream_4);
	eval 'sub bus_space_write_region_stream_8 () { &bus_space_write_region_8;}' unless defined(&bus_space_write_region_stream_8);
	eval 'sub bus_space_set_multi_stream_1 () { &bus_space_set_multi_1;}' unless defined(&bus_space_set_multi_stream_1);
	eval 'sub bus_space_set_multi_stream_2 () { &bus_space_set_multi_2;}' unless defined(&bus_space_set_multi_stream_2);
	eval 'sub bus_space_set_multi_stream_4 () { &bus_space_set_multi_4;}' unless defined(&bus_space_set_multi_stream_4);
	eval 'sub bus_space_set_multi_stream_8 () { &bus_space_set_multi_8;}' unless defined(&bus_space_set_multi_stream_8);
	eval 'sub bus_space_set_region_stream_1 () { &bus_space_set_region_1;}' unless defined(&bus_space_set_region_stream_1);
	eval 'sub bus_space_set_region_stream_2 () { &bus_space_set_region_2;}' unless defined(&bus_space_set_region_stream_2);
	eval 'sub bus_space_set_region_stream_4 () { &bus_space_set_region_4;}' unless defined(&bus_space_set_region_stream_4);
	eval 'sub bus_space_set_region_stream_8 () { &bus_space_set_region_8;}' unless defined(&bus_space_set_region_stream_8);
	eval 'sub bus_space_copy_region_stream_1 () { &bus_space_copy_region_1;}' unless defined(&bus_space_copy_region_stream_1);
	eval 'sub bus_space_copy_region_stream_2 () { &bus_space_copy_region_2;}' unless defined(&bus_space_copy_region_stream_2);
	eval 'sub bus_space_copy_region_stream_4 () { &bus_space_copy_region_4;}' unless defined(&bus_space_copy_region_stream_4);
	eval 'sub bus_space_copy_region_stream_8 () { &bus_space_copy_region_8;}' unless defined(&bus_space_copy_region_stream_8);
    }
    require 'machine/bus_dma.ph';
}
1;
