require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CPUFUNC_H_)) {
    eval 'sub _MACHINE_CPUFUNC_H_ () {1;}' unless defined(&_MACHINE_CPUFUNC_H_);
    if(defined(&_KERNEL)) {
	require 'sys/types.ph';
	require 'machine/ia64_cpu.ph';
	require 'machine/vmparam.ph';
	unless(defined(&_SYS_CDEFS_H_)) {
	    die("this\ file\ needs\ sys\/cdefs\.h\ as\ a\ prerequisite");
	}
	eval 'sub IA64_FIXED_BREAK () {0x84b5d;}' unless defined(&IA64_FIXED_BREAK);
	if(defined(&__GNUCLIKE_ASM)) {
	    eval 'sub breakpoint {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile(\\"break.m %0\\" :: \\"i\\"( &IA64_FIXED_BREAK)); });
	    }' unless defined(&breakpoint);
	    eval 'sub HAVE_INLINE_FFS () {1;}' unless defined(&HAVE_INLINE_FFS);
	    eval 'sub ffs {
	        my($x) = @_;
    		eval q( &__builtin_ffs($x));
	    }' unless defined(&ffs);
	    eval 'sub ia64_disable_intr {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile (\\"rsm psr.i\\"); });
	    }' unless defined(&ia64_disable_intr);
	    eval 'sub ia64_enable_intr {
	        my($void) = @_;
    		eval q({  &__asm  &__volatile (\\"ssm psr.i;; srlz.d\\"); });
	    }' unless defined(&ia64_enable_intr);
	    eval 'sub intr_disable {
	        my($void) = @_;
    		eval q({  &register_t  &psr;  &__asm  &__volatile (\\"mov %0=psr;;\\" : \\"=r\\"( &psr));  &ia64_disable_intr(); (( &psr &  &IA64_PSR_I) ? 1: 0); });
	    }' unless defined(&intr_disable);
	    eval 'sub intr_restore {
	        my($ie) = @_;
    		eval q({  &if ($ie)  &ia64_enable_intr(); });
	    }' unless defined(&intr_restore);
	}
    }
}
1;
