require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_DB_MACHDEP_H_)) {
    eval 'sub _MACHINE_DB_MACHDEP_H_ () {1;}' unless defined(&_MACHINE_DB_MACHDEP_H_);
    require 'machine/ia64_cpu.ph';
    eval 'sub DB_MACHINE_COMMANDS () {1;}' unless defined(&DB_MACHINE_COMMANDS);
    eval 'sub DB_ELFSIZE () {64;}' unless defined(&DB_ELFSIZE);
    eval 'sub DB_SMALL_VALUE_MAX () {0x7fffffff;}' unless defined(&DB_SMALL_VALUE_MAX);
    eval 'sub DB_SMALL_VALUE_MIN () {(-0x400001);}' unless defined(&DB_SMALL_VALUE_MIN);
    eval 'sub PC_REGS () {
        eval q((( ($kdb_thrctx->{pcb_special}->{__spare}) == 0) ?  ($kdb_thrctx->{pcb_special}->{rp}) :  ($kdb_thrctx->{pcb_special}->{iip}) + (( ($kdb_thrctx->{pcb_special}->{psr})>>41) & 3)));
    }' unless defined(&PC_REGS);
    eval 'sub BKPT_WRITE {
        my($addr, $storage) = @_;
	    eval q( &db_bkpt_write($addr, $storage));
    }' unless defined(&BKPT_WRITE);
    eval 'sub BKPT_CLEAR {
        my($addr, $storage) = @_;
	    eval q( &db_bkpt_clear($addr, $storage));
    }' unless defined(&BKPT_CLEAR);
    eval 'sub BKPT_SKIP () { &db_bkpt_skip();}' unless defined(&BKPT_SKIP);
    eval 'sub BKPT_INST_TYPE () { &uint64_t;}' unless defined(&BKPT_INST_TYPE);
    eval 'sub db_clear_single_step () { &kdb_cpu_clear_singlestep;}' unless defined(&db_clear_single_step);
    eval 'sub db_set_single_step () { &kdb_cpu_set_singlestep;}' unless defined(&db_set_single_step);
    eval 'sub IS_BREAKPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(($type ==  &IA64_VEC_BREAK));
    }' unless defined(&IS_BREAKPOINT_TRAP);
    eval 'sub IS_WATCHPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(0);
    }' unless defined(&IS_WATCHPOINT_TRAP);
    eval 'sub inst_trap_return {
        my($ins) = @_;
	    eval q(($ins & 0));
    }' unless defined(&inst_trap_return);
    eval 'sub inst_return {
        my($ins) = @_;
	    eval q(($ins & 0));
    }' unless defined(&inst_return);
    eval 'sub inst_call {
        my($ins) = @_;
	    eval q(($ins & 0));
    }' unless defined(&inst_call);
    eval 'sub inst_branch {
        my($ins) = @_;
	    eval q(($ins & 0));
    }' unless defined(&inst_branch);
    eval 'sub inst_load {
        my($ins) = @_;
	    eval q(($ins & 0));
    }' unless defined(&inst_load);
    eval 'sub inst_store {
        my($ins) = @_;
	    eval q(($ins & 0));
    }' unless defined(&inst_store);
    eval 'sub inst_unconditional_flow_transfer {
        my($ins) = @_;
	    eval q(($ins & 0));
    }' unless defined(&inst_unconditional_flow_transfer);
    eval 'sub branch_taken {
        my($ins, $pc, $regs) = @_;
	    eval q($pc);
    }' unless defined(&branch_taken);
    eval 'sub DB_MAXARGS () {8;}' unless defined(&DB_MAXARGS);
    eval 'sub DB_CALL () { &db_fncall_ia64;}' unless defined(&DB_CALL);
}
1;
