require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ELF_H_)) {
    eval 'sub _MACHINE_ELF_H_ () {1;}' unless defined(&_MACHINE_ELF_H_);
    unless(defined(&__ELF_WORD_SIZE)) {
	eval 'sub __ELF_WORD_SIZE () {64;}' unless defined(&__ELF_WORD_SIZE);
    }
    require 'sys/elf64.ph';
    require 'sys/elf32.ph';
    require 'sys/elf_generic.ph';
    eval 'sub ELF_ARCH () { &EM_IA_64;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_ARCH32 () { &EM_386;}' unless defined(&ELF_ARCH32);
    eval 'sub ELF_MACHINE_OK {
        my($x) = @_;
	    eval q((($x) ==  &EM_IA_64));
    }' unless defined(&ELF_MACHINE_OK);
    eval 'sub AT_NULL () {0;}' unless defined(&AT_NULL);
    eval 'sub AT_IGNORE () {1;}' unless defined(&AT_IGNORE);
    eval 'sub AT_EXECFD () {2;}' unless defined(&AT_EXECFD);
    eval 'sub AT_PHDR () {3;}' unless defined(&AT_PHDR);
    eval 'sub AT_PHENT () {4;}' unless defined(&AT_PHENT);
    eval 'sub AT_PHNUM () {5;}' unless defined(&AT_PHNUM);
    eval 'sub AT_PAGESZ () {6;}' unless defined(&AT_PAGESZ);
    eval 'sub AT_BASE () {7;}' unless defined(&AT_BASE);
    eval 'sub AT_FLAGS () {8;}' unless defined(&AT_FLAGS);
    eval 'sub AT_ENTRY () {9;}' unless defined(&AT_ENTRY);
    eval 'sub AT_NOTELF () {10;}' unless defined(&AT_NOTELF);
    eval 'sub AT_UID () {11;}' unless defined(&AT_UID);
    eval 'sub AT_EUID () {12;}' unless defined(&AT_EUID);
    eval 'sub AT_GID () {13;}' unless defined(&AT_GID);
    eval 'sub AT_EGID () {14;}' unless defined(&AT_EGID);
    eval 'sub AT_EXECPATH () {15;}' unless defined(&AT_EXECPATH);
    eval 'sub AT_CANARY () {16;}' unless defined(&AT_CANARY);
    eval 'sub AT_CANARYLEN () {17;}' unless defined(&AT_CANARYLEN);
    eval 'sub AT_OSRELDATE () {18;}' unless defined(&AT_OSRELDATE);
    eval 'sub AT_NCPUS () {19;}' unless defined(&AT_NCPUS);
    eval 'sub AT_PAGESIZES () {20;}' unless defined(&AT_PAGESIZES);
    eval 'sub AT_PAGESIZESLEN () {21;}' unless defined(&AT_PAGESIZESLEN);
    eval 'sub AT_TIMEKEEP () {22;}' unless defined(&AT_TIMEKEEP);
    eval 'sub AT_STACKPROT () {23;}' unless defined(&AT_STACKPROT);
    eval 'sub AT_COUNT () {24;}' unless defined(&AT_COUNT);
    eval 'sub EF_IA_64_MASKOS () {0xff000f;}' unless defined(&EF_IA_64_MASKOS);
    eval 'sub EF_IA_64_ABI64 () {0x10;}' unless defined(&EF_IA_64_ABI64);
    eval 'sub EF_IA_64_REDUCEDFP () {0x20;}' unless defined(&EF_IA_64_REDUCEDFP);
    eval 'sub EF_IA_64_CONS_GP () {0x40;}' unless defined(&EF_IA_64_CONS_GP);
    eval 'sub EF_IA_64_NOFUNCDESC_CONS_GP () {0x80;}' unless defined(&EF_IA_64_NOFUNCDESC_CONS_GP);
    eval 'sub EF_IA_64_ABSOLUTE () {0x100;}' unless defined(&EF_IA_64_ABSOLUTE);
    eval 'sub EF_IA_64_ARCH () {0xff000000;}' unless defined(&EF_IA_64_ARCH);
    eval 'sub PT_IA_64_ARCHEXT () {0x70000000;}' unless defined(&PT_IA_64_ARCHEXT);
    eval 'sub PT_IA_64_UNWIND () {0x70000001;}' unless defined(&PT_IA_64_UNWIND);
    eval 'sub PF_IA_64_NORECOV () {0x80000000;}' unless defined(&PF_IA_64_NORECOV);
    eval 'sub SHT_IA_64_EXT () {0x70000000;}' unless defined(&SHT_IA_64_EXT);
    eval 'sub SHT_IA_64_UNWIND () {0x70000001;}' unless defined(&SHT_IA_64_UNWIND);
    eval 'sub SHT_IA_64_LOPSREG () {0x78000000;}' unless defined(&SHT_IA_64_LOPSREG);
    eval 'sub SHT_IA_64_HIPSREG () {0x7fffffff;}' unless defined(&SHT_IA_64_HIPSREG);
    eval 'sub SHF_IA_64_SHORT () {0x10000000;}' unless defined(&SHF_IA_64_SHORT);
    eval 'sub SHF_IA_64_NORECOV () {0x20000000;}' unless defined(&SHF_IA_64_NORECOV);
    if((defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : undef) == 32) {
	eval 'sub ELF_TARG_CLASS () { &ELFCLASS32;}' unless defined(&ELF_TARG_CLASS);
    } else {
	eval 'sub ELF_TARG_CLASS () { &ELFCLASS64;}' unless defined(&ELF_TARG_CLASS);
    }
    eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
    eval 'sub ELF_TARG_MACH () { &EM_IA_64;}' unless defined(&ELF_TARG_MACH);
    eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
    eval 'sub DT_IA_64_PLT_RESERVE () {0x70000000;}' unless defined(&DT_IA_64_PLT_RESERVE);
    eval 'sub ET_DYN_LOAD_ADDR () {0x2500000000000000;}' unless defined(&ET_DYN_LOAD_ADDR);
}
1;
