require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IA64_INCLUDE_PARAM_H_)) {
    eval 'sub _IA64_INCLUDE_PARAM_H_ () {1;}' unless defined(&_IA64_INCLUDE_PARAM_H_);
    require 'machine/_align.ph';
    eval 'sub __HAVE_ACPI () {1;}' unless defined(&__HAVE_ACPI);
    eval 'sub __PCI_REROUTE_INTERRUPT () {1;}' unless defined(&__PCI_REROUTE_INTERRUPT);
    unless(defined(&MACHINE)) {
	eval 'sub MACHINE () {"ia64";}' unless defined(&MACHINE);
    }
    unless(defined(&MACHINE_ARCH)) {
	eval 'sub MACHINE_ARCH () {"ia64";}' unless defined(&MACHINE_ARCH);
    }
    unless(defined(&MACHINE_ARCH32)) {
	eval 'sub MACHINE_ARCH32 () {"i386";}' unless defined(&MACHINE_ARCH32);
    }
    if(defined(&SMP) || defined(&KLD_MODULE)) {
	unless(defined(&MAXCPU)) {
	    eval 'sub MAXCPU () {64;}' unless defined(&MAXCPU);
	}
    } else {
	eval 'sub MAXCPU () {1;}' unless defined(&MAXCPU);
    }
    unless(defined(&MAXMEMDOM)) {
	eval 'sub MAXMEMDOM () {1;}' unless defined(&MAXMEMDOM);
    }
    eval 'sub ALIGNBYTES () { &_ALIGNBYTES;}' unless defined(&ALIGNBYTES);
    eval 'sub ALIGN {
        my($p) = @_;
	    eval q( &_ALIGN($p));
    }' unless defined(&ALIGN);
    eval 'sub ALIGNED_POINTER {
        my($p,$t) = @_;
	    eval q((((($p)) & ($sizeof{$t}-1)) == 0));
    }' unless defined(&ALIGNED_POINTER);
    eval 'sub CACHE_LINE_SHIFT () {7;}' unless defined(&CACHE_LINE_SHIFT);
    eval 'sub CACHE_LINE_SIZE () {(1<<  &CACHE_LINE_SHIFT);}' unless defined(&CACHE_LINE_SIZE);
    unless(defined(&LOG2_PAGE_SIZE)) {
	eval 'sub LOG2_PAGE_SIZE () {13;}' unless defined(&LOG2_PAGE_SIZE);
    }
    eval 'sub PAGE_SHIFT () {( &LOG2_PAGE_SIZE);}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1<<( &LOG2_PAGE_SIZE));}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {( &PAGE_SIZE-1);}' unless defined(&PAGE_MASK);
    eval 'sub NPTEPG () {( &PAGE_SIZE/($sizeof{ &pt_entry_t}));}' unless defined(&NPTEPG);
    eval 'sub MAXPAGESIZES () {1;}' unless defined(&MAXPAGESIZES);
    unless(defined(&KSTACK_PAGES)) {
	eval 'sub KSTACK_PAGES () {4;}' unless defined(&KSTACK_PAGES);
    }
    eval 'sub KSTACK_GUARD_PAGES () {0;}' unless defined(&KSTACK_GUARD_PAGES);
    unless(defined(&LOG2_ID_PAGE_SIZE)) {
	eval 'sub LOG2_ID_PAGE_SIZE () {16;}' unless defined(&LOG2_ID_PAGE_SIZE);
    }
    eval 'sub round_page {
        my($x) = @_;
	    eval q((((($x)) +  &PAGE_MASK) & ~( &PAGE_MASK)));
    }' unless defined(&round_page);
    eval 'sub trunc_page {
        my($x) = @_;
	    eval q((($x) & ~( &PAGE_MASK)));
    }' unless defined(&trunc_page);
    eval 'sub atop {
        my($x) = @_;
	    eval q((($x) >>  &PAGE_SHIFT));
    }' unless defined(&atop);
    eval 'sub ptoa {
        my($x) = @_;
	    eval q((($x) <<  &PAGE_SHIFT));
    }' unless defined(&ptoa);
    eval 'sub pgtok {
        my($x) = @_;
	    eval q((($x) * ( &PAGE_SIZE / 1024)));
    }' unless defined(&pgtok);
    if(defined(&_KERNEL)) {
	eval 'sub NO_FUEWORD () {1;}' unless defined(&NO_FUEWORD);
    }
}
1;
