require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PMAP_H_)) {
    eval 'sub _MACHINE_PMAP_H_ () {1;}' unless defined(&_MACHINE_PMAP_H_);
    require 'sys/queue.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    require 'machine/atomic.ph';
    require 'machine/pte.ph';
    require 'machine/vmparam.ph';
    if(defined(&_KERNEL)) {
	eval 'sub MAXKPT () {( &PAGE_SIZE/$sizeof{ &vm_offset_t});}' unless defined(&MAXKPT);
	eval 'sub vtophys {
	    my($va) = @_;
    	    eval q( &pmap_kextract(( &vm_offset_t)($va)));
	}' unless defined(&vtophys);
    }
    if(defined(&_KERNEL)) {
	eval 'sub kernel_pmap () {( &kernel_pmap_store);}' unless defined(&kernel_pmap);
	eval 'sub PMAP_LOCK {
	    my($pmap) = @_;
    	    eval q( &mtx_lock(($pmap)-> &pm_mtx));
	}' unless defined(&PMAP_LOCK);
	eval 'sub PMAP_LOCK_ASSERT {
	    my($pmap, $type) = @_;
    	    eval q( &mtx_assert(($pmap)-> &pm_mtx, ($type)));
	}' unless defined(&PMAP_LOCK_ASSERT);
	eval 'sub PMAP_LOCK_DESTROY {
	    my($pmap) = @_;
    	    eval q( &mtx_destroy(($pmap)-> &pm_mtx));
	}' unless defined(&PMAP_LOCK_DESTROY);
	eval 'sub PMAP_LOCK_INIT {
	    my($pmap) = @_;
    	    eval q( &mtx_init(($pmap)-> &pm_mtx, \\"pmap\\",  &NULL,  &MTX_DEF));
	}' unless defined(&PMAP_LOCK_INIT);
	eval 'sub PMAP_LOCKED {
	    my($pmap) = @_;
    	    eval q( &mtx_owned(($pmap)-> &pm_mtx));
	}' unless defined(&PMAP_LOCKED);
	eval 'sub PMAP_MTX {
	    my($pmap) = @_;
    	    eval q((($pmap)-> &pm_mtx));
	}' unless defined(&PMAP_MTX);
	eval 'sub PMAP_TRYLOCK {
	    my($pmap) = @_;
    	    eval q( &mtx_trylock(($pmap)-> &pm_mtx));
	}' unless defined(&PMAP_TRYLOCK);
	eval 'sub PMAP_UNLOCK {
	    my($pmap) = @_;
    	    eval q( &mtx_unlock(($pmap)-> &pm_mtx));
	}' unless defined(&PMAP_UNLOCK);
    }
    if(defined(&_KERNEL)) {
	eval 'sub pmap_mapbios {
	    my($pa,$sz) = @_;
    	    eval q( &pmap_mapdev_attr($pa,$sz, &VM_MEMATTR_UNCACHEABLE));
	}' unless defined(&pmap_mapbios);
	eval 'sub pmap_mapdev {
	    my($pa,$sz) = @_;
    	    eval q( &pmap_mapdev_attr($pa,$sz, &VM_MEMATTR_UNCACHEABLE));
	}' unless defined(&pmap_mapdev);
	eval 'sub pmap_unmapbios {
	    my($va,$sz) = @_;
    	    eval q( &pmap_unmapdev($va,$sz));
	}' unless defined(&pmap_unmapbios);
	eval 'sub pmap_page_get_memattr {
	    my($m) = @_;
    	    eval q((($m)-> ($md->{memattr})));
	}' unless defined(&pmap_page_get_memattr);
	eval 'sub pmap_page_is_mapped {
	    my($m) = @_;
    	    eval q((! &TAILQ_EMPTY(($m)-> ($md->{pv_list}))));
	}' unless defined(&pmap_page_is_mapped);
	eval 'sub pmap_page_is_write_mapped {
	    my($m) = @_;
    	    eval q(((($m)-> &aflags &  &PGA_WRITEABLE) != 0));
	}' unless defined(&pmap_page_is_write_mapped);
    }
}
1;
